Module Ecotaxes
===============

Ce module permet d'ajouter des lignes de services 'écotaxes' sur des lignes d'objets (propales, devis, factures, etc.)

Compatibilité DLB 17 -> 21

Extrafields
-----------
crée les extrafields :
- `ecotax_ecotax`: liste de sélection issue du dictionnaire `c_ecotax_type` qui permet d'indiquer le type d'écotaxe
- `ecotax_unit_amount`: Montant par unité. Ce champs est affiché si la valeur de l'EF `ecotax_ecotax` correspond à une ecotaxe calculée par unité

Dictionnaire
------------
- `c_ecotax_type` : le type d'écotaxe. Utilisé par l'EF `ecotax_ecotax`.

Hooks
-----
- `doActions` : lors de la création d'une facture fourn depuis une réception, permet la création des écotaxte en activant la constante `ECOTAX_ALSO_ON_LINK_ORIGIN`
- `viewDictionaryFieldlist`, `createDictionaryFieldlist` et `editDictionaryFieldlist` pour gérer le comportement des lignes d'ecotaxe
- `printObjectLine` et `printObjectSubLine` modifient l'affichage des lignes
- `selectProductsListWhere`, `selectSuppliersProductsListWhere` : ?
- `getNomUrl` : ajouter l'info du type d'écotaxe dans l'infobulle des produits sur les lignes de facture, propal, etc.
- `pdf_writelinedesc` et `afterPDFTotalTable` pour modifier l'affichage sur les PDFs.
- `doActions` pour gérer l'ajout d'écotaxes sur les factures fournisseur lors d'une création depuis la carte réception ou la liste des réceptions.

Triggers
--------

L'ajout, modification, suppression des lignes d'ecotaxe se fait sur les triggers:
- `LINEXXX_INSERT` ou `LINEXXX_CREATE`
- `LINEXXX_UPDATE` ou `LINEXXX_MODIFY`
- `LINEXXX_DELETE`

Modèles de PDF
--------------

Ajout de modèles contenant les informations d'écotaxes sur les objets suivants :
- commande (eratosthene_ecotax)
- facture (sponge_ecotax)
- propale (cyan_ecotax)
- facture fourn (cannelle_ecotax)
- commande fourn (cornas_ecotax)

Constantes
----------

### Paramétrables

- `ECOTAX_WORKFLOW_RECEPTION_CLASSIFY_CLOSED_INVOICE` : classer les réceptions comme 'traitées' quand la facture fournisseur à laquelle elles sont liées est validée, SI le total des lignes sans écotaxes correspond au total des réceptions liées à la facture.
- `ECOTAX_SET_SUPPLIER_ORDER_FULL_RECEIVED` : classer les commandes fournisseur 'tous les produits reçus' **en prenant en compte** les écotaxes. Le fonctionnement par défaut sera de ne comparer que les lignes non ecotaxes pour classer une commande fournisseur comme 'totalement reçue'.

### Deux constantes cachées :
- `ECOTAX_ALSO_ON_CREATE_FROM_CLONE`
- `ECOTAX_ALSO_ON_LINK_ORIGIN`

En temps normal, la création/modification d'ecotaxe n'est pas active si un objet est cloné ou créé depuis un autre objet, car on suppose que les écotaxes sont déjà présentes sur les objets d'origine. Ces deux constantes suppriment ce contrôle (et donc provoquent l'ajout/modification des écotaxes). Ceci permet de générer des comportements compliqués avec d'autres modules.